#include <QCoreApplication>
#include <QTimer>
#include "signal_emitter.h"

int main(int argc, char *argv[])
{
  QCoreApplication app(argc, argv);

  // emitter is now a child of core application app.
  // app will delete emitter.
  signal_emitter *emitter = new signal_emitter(&app);

  // when emitter emits 'finished' signal, app will be terminated.
  QObject::connect(emitter, SIGNAL(finished()), &app, SLOT(quit()));

  // we emit initial 'launch()'.
  QTimer::singleShot(0, emitter, SLOT(launch()));

  return app.exec();
}
